var Player = cc.Class.extend({
    ctor: function () {
        this.config = utils.clone(playerConfig);

        this.hp = Number.parseInt('11110000', 2);
        this.hp = memoryUtil.encode(this.hp);
        this.hpMaxOrigin = Number.parseInt('11110000', 2);
        this.hpMaxOrigin = memoryUtil.encode(this.hpMaxOrigin);
        this.hpMax = this.hpMaxOrigin;
        //心情
        this.spirit = Number.parseInt('1100100', 2);
        this.spirit = memoryUtil.encode(this.spirit);
        this.spiritMax = Number.parseInt('1100100', 2);
        this.spiritMax = memoryUtil.encode(this.spiritMax);
        //饥饿
        this.starve = Number.parseInt('110010', 2);
        this.starve = memoryUtil.encode(this.starve);
        this.starveMax = Number.parseInt('1100100', 2);
        this.starveMax = memoryUtil.encode(this.starveMax);
        //精力
        this.vigour = Number.parseInt('1100100', 2);
        this.vigour = memoryUtil.encode(this.vigour);
        this.vigourMax = Number.parseInt('1100100', 2);
        this.vigourMax = memoryUtil.encode(this.vigourMax);
        //外伤
        this.injury = Number.parseInt('0', 2);
        this.injury = memoryUtil.encode(this.injury);
        this.injuryMax = Number.parseInt('1100100', 2);
        this.injuryMax = memoryUtil.encode(this.injuryMax);
        //感染
        this.infect = Number.parseInt('0', 2);
        this.infect = memoryUtil.encode(this.infect);
        this.infectMax = Number.parseInt('1100100', 2);
        this.infectMax = memoryUtil.encode(this.infectMax);
        //温度
        this.temperature = this.initTemperature();
        this.temperature = memoryUtil.encode(this.temperature);
        this.temperatureMax = Number.parseInt('1100100', 2);
        this.temperatureMax = memoryUtil.encode(this.temperatureMax);


        //睡眠状态
        this.isInSleep = false;
        //服药状态
        this.cured = false;
        //包扎状态
        this.binded = false;

        //是否在家
        this.isAtHome = true;
        //是否在副本
        this.isAtSite = false;
        this.nowSiteId = null;

        //是否因为感染死亡
        this.deathCausedInfect = false;

        //战斗前状态记录
        this.battleRecord = null;

        this.bag = new Bag('player');
        this.storage = new Storage('player');

        this.dog = new Dog();
        this.room = new Room();
        this.equip = new Equipment();
        this.npcManager = new NPCManager();
        this.map = new Map();
        this.log = new Log();
        this.weather = new WeatherSystem();
        this.buffManager = new BuffManager();

        this.setting = {};

        this.roleType = role.getChoosenRoleType();
        this.isBombActive = false;
    },

    save: function () {
        var opt = {
            hp: memoryUtil.decode(this.hp),
            hpMaxOrigin: memoryUtil.decode(this.hpMaxOrigin),
            hpMax: memoryUtil.decode(this.hpMax),
            spirit: memoryUtil.decode(this.spirit),
            starve: memoryUtil.decode(this.starve),
            vigour: memoryUtil.decode(this.vigour),
            injury: memoryUtil.decode(this.injury),
            infect: memoryUtil.decode(this.infect),
            temperature: memoryUtil.decode(this.temperature),

            //fix bug: 睡觉中强退后一直处于睡眠状态
            //isInSleep: this.isInSleep,
            cured: this.cured,
            cureTime: this.cureTime,
            binded: this.binded,
            bindTime: this.bindTime,
            isAtHome: this.isAtHome,
            isAtSite: this.isAtSite,
            nowSiteId: this.nowSiteId,
            deathCausedInfect: this.deathCausedInfect,

            setting: this.setting,

            bag: this.bag.save(),
            storage: this.storage.save(),
            dog: this.dog.save(),
            room: this.room.save(),
            equip: this.equip.save(),
            map: this.map.save(),
            npcManager: this.npcManager.save(),
            weather: this.weather.save(),
            buffManager: this.buffManager.save(),

            isBombActive: this.isBombActive
        };

        return opt;
    },

    restore: function () {
        var opt = Record.restore("player");
        if (opt) {
            this.hp = memoryUtil.encode(opt.hp);
            this.hpMaxOrigin = memoryUtil.encode(opt.hpMaxOrigin);
            this.hpMax = memoryUtil.encode(opt.hpMax);
            this.spirit = memoryUtil.encode(opt.spirit);
            this.starve = memoryUtil.encode(opt.starve);
            this.vigour = memoryUtil.encode(opt.vigour);
            this.injury = memoryUtil.encode(opt.injury);
            this.infect = memoryUtil.encode(opt.infect);
            this.temperature = memoryUtil.encode(opt.temperature);
            //fix bug: 睡觉中强退后一直处于睡眠状态
            //this.isInSleep = opt.isInSleep;
            this.cured = opt.cured;
            this.cureTime = opt.cureTime;
            this.binded = opt.binded;
            this.bindTime = opt.bindTime;
            this.isAtHome = opt.isAtHome;
            this.isAtSite = opt.isAtSite;
            this.nowSiteId = opt.nowSiteId;
            this.deathCausedInfect = opt.deathCausedInfect;
            this.setting = opt.setting;
            this.bag.restore(opt.bag);
            this.storage.restore(opt.storage);
            this.dog.restore(opt.dog);
            this.equip.restore(opt.equip);
            this.weather.restore(opt.weather);
            this.buffManager.restore(opt.buffManager);
            this.isBombActive = opt.isBombActive;
        } else {
            // for test ---------begin------------
            //var itemList = [1305023, 1305024, 1304024, 1305034, 1305044, 1305034, 1305044, 1305053, 1305064];
            //for (var itemId in itemConfig) {
            //    itemId = Number(itemId);
            //    if (itemList.indexOf(itemId) == -1) {
            //        this.storage.increaseItem(itemId, 100);
            //    }
            //}
            //this.storage.increaseItem(1305064, 1);
            // for test ---------end------------

            IAPPackage.init(this);
            Medal.improve(this);
            //分享奖励
            if (Record.getShareFlag() === ShareType.SHARED_CAN_REWARD) {
                Record.setShareFlag(ShareType.SHARED_AND_REWARD);
                this.storage.increaseItem(1106054, 1);
            }
        }

        this.room.restore(opt ? opt.room : null);
        this.npcManager.restore(opt ? opt.npcManager : null);
        this.map.restore(opt ? opt.map : null);


        if (IAPPackage.isBigBagUnlocked() && !this.storage.validateItem(1305024, 1)) {
            this.storage.increaseItem(1305024, 1);
        }

        if (IAPPackage.isBootUnlocked() && !this.storage.validateItem(1304024, 1)) {
            this.storage.increaseItem(1304024, 1);
        }

        if (IAPPackage.isDogHouseUnlocked() && !player.room.isBuildExist(12, 0)) {
            this.room.createBuild(12, 0);
        }

    },

    //包扎
    bindUp: function () {
        this.binded = true;
        this.bindTime = cc.timer.now();
    },
    //包扎状态不可以再包扎
    isInBind: function () {
        return this.binded;
    },

    //服药
    cure: function () {
        this.cured = true;
        this.cureTime = cc.timer.now();
    },

    //服药状态可以再服药
    isInCure: function () {
        return this.cured;
    },

    goHome: function () {
        this.isAtHome = true;
    },

    out: function () {
        this.isAtHome = false;
    },

    enterSite: function (siteId) {
        this.isAtSite = true;
        this.nowSiteId = siteId;
    },
    outSite: function () {
        this.isAtSite = false;
        this.nowSiteId = 0;
    },

    sleep: function () {
        this.isInSleep = true;
    },
    wakeUp: function () {
        this.isInSleep = false;
    },

    isAttrChangeGood: function (key, value) {
        switch (key) {
            case "hp":
                return value >= 0;
            case "spirit":
                return value >= 0;
            case "starve":
                return value >= 0;
            case "vigour":
                return value >= 0;
            case "injury":
                return value < 0;
            case "infect":
                return value < 0;
            case "temperature":
                return value >= 0;
        }
    },

    isAttrMax: function (key) {
        return memoryUtil.decode(this[key]) == memoryUtil.decode(this[key + "Max"]);
    },

    getAttrPercentage: function (key) {
        return memoryUtil.decode(this[key]) / memoryUtil.decode(this[key + "Max"]);
    },

    changeAttr: function (key, value) {
        if (!this.isAttrChangeGood(key, value)) {
            if (key === 'infect' && this.buffManager.isBuffEffect(BuffItemEffectType.ITEM_1107022)) {
                cc.d('ITEM_1107022 effect infect');
                return;
            }
            if (key === 'starve' && this.buffManager.isBuffEffect(BuffItemEffectType.ITEM_1107042)) {
                cc.d('ITEM_1107042 effect starve');
                return;
            }
            if (key === 'vigour' && this.buffManager.isBuffEffect(BuffItemEffectType.ITEM_1107032)) {
                cc.d('ITEM_1107032 effect vigour');
                return;
            }
        }
        var beforeRangeInfo = this.getAttrRangeInfo(key, this[key]);
        this[key] += memoryUtil.changeEncode(value);
        this[key] = memoryUtil.encode(cc.clampf(memoryUtil.decode(this[key]), 0, memoryUtil.decode(this[key + "Max"])));
        var afterRangeInfo = this.getAttrRangeInfo(key, this[key]);

        cc.i("changeAttr " + key + " value:" + value + " after:" + memoryUtil.decode(this[key]));
        if (this === player) {
            utils.emitter.emit(key + "_change", value);
        }
        if (beforeRangeInfo && afterRangeInfo) {
            var suffix;
            if (afterRangeInfo.id - beforeRangeInfo.id > 0) {
                suffix = "_up";
                cc.e(key + suffix + " " + (afterRangeInfo.id - 1));
                this.log.addMsg(stringUtil.getString(key + suffix)[afterRangeInfo.id - 1]);
                if (key === "infect" || key === "injury") {
                    audioManager.playEffect(audioManager.sound.BAD_EFFECT);
                } else {
                    audioManager.playEffect(audioManager.sound.GOOD_EFFECT);
                }
            } else if (afterRangeInfo.id - beforeRangeInfo.id < 0) {
                suffix = "_down";
                cc.e(key + suffix + " " + (afterRangeInfo.id - 1));
                this.log.addMsg(stringUtil.getString(key + suffix)[afterRangeInfo.id - 1]);
                if (key === "infect" || key === "injury") {
                    audioManager.playEffect(audioManager.sound.GOOD_EFFECT);
                } else {
                    audioManager.playEffect(audioManager.sound.BAD_EFFECT);
                }
            }
        } else {
            cc.e(key + " is not in range " + this[key]);
        }

        if (key === "injury") {
            this.updateHpMax();
        }

        if (key === "hp") {
            if (memoryUtil.decode(this.hp) == 0 && this === player) {
                //die
                this.die();
            }
        }
    },
    changeHp: function (value) {
        this.changeAttr("hp", value);
    },

    changeStarve: function (value) {
        this.changeAttr("starve", value);
    },

    changeSpirit: function (value) {
        this.changeAttr("spirit", value);
    },

    changeVigour: function (value) {
        this.changeAttr("vigour", value);
    },

    changeInjury: function (value) {
        this.changeAttr("injury", value);
    },

    changeInfect: function (value) {
        this.changeAttr("infect", value);
    },

    changeTemperature: function (value) {
        this.changeAttr("temperature", value);
    },

    updateHpMax: function () {
        var hpBuffEffect = 0;
        if (this.buffManager.isBuffEffect(BuffItemEffectType.ITEM_1107012)) {
            hpBuffEffect = this.buffManager.getBuffValue();
        }
        this.hpMax = memoryUtil.encode(memoryUtil.decode(this.hpMaxOrigin) + hpBuffEffect - memoryUtil.decode(this.injury));
        this.hp = memoryUtil.encode(Math.min(memoryUtil.decode(this.hp), memoryUtil.decode(this.hpMax)));
    },

    updateByTime: function () {

        var c = this.config["changeByTime"];

        //扣减饥饿度
        this.changeStarve(c[0][0]);
        //扣减狗的饥饿度
        this.dog.changeStarve(c[1][0]);

        /*
         白天家中，精力值	-1
         白天野外，精力值	-2
         夜晚家中，精力值	-3
         夜晚野外，精力值	-4
         */
        if (cc.timer.getStage() === "day") {
            if (this.isAtHome) {
                this.changeVigour(c[2][0]);
            } else {
                this.changeVigour(c[3][0]);
            }
        } else {
            if (this.isAtHome) {
                this.changeVigour(c[4][0]);
            } else {
                this.changeVigour(c[5][0]);
            }
        }

        //在睡眠状态下的影响
        if (this.isInSleep) {
            var bedLevel = player.room.getBuildLevel(9);
            var bedRate = buildActionConfig[9][bedLevel].rate;

            //睡眠等级=床等级值*0.5+饱食度/100*0.2+心情值/100*0.3
            bedRate = bedRate * 0.5 + memoryUtil.decode(this.starve) / memoryUtil.decode(this.starveMax) * 0.2 + memoryUtil.decode(this.spirit) / memoryUtil.decode(this.spiritMax) * 0.3;

            //精力值
            //每小时回复精力值=睡眠等级*10
            var vigour = bedRate * 15;
            vigour = Math.ceil(vigour);
            this.changeVigour(vigour);

            //生命值
            //每小时回血=睡眠等级*20
            var hp = bedRate * 20;
            hp = Math.ceil(hp);
            this.changeHp(hp)
        }

        //天气影响
        this.changeVigour(this.weather.getValue("vigour"));
        this.changeSpirit(this.weather.getValue("spirit"));
    },

    updateStarve: function () {
        if (this.buffManager.isBuffEffect(BuffItemEffectType.ITEM_1107042)) {
            cc.d('ITEM_1107042 updateStarve');
            return;
        }

        var attrRangeInfo = this.getAttrRangeInfo("starve", this.starve);
        if (attrRangeInfo) {
            var effect = attrRangeInfo.effect;
            for (var attr in effect) {
                if (this.hasOwnProperty(attr)) {
                    this.changeAttr(attr, effect[attr]);
                }
            }
        }

    },

    updateInfect: function () {

        if (this.buffManager.isBuffEffect(BuffItemEffectType.ITEM_1107022)) {
            cc.d('ITEM_1107022 updateInfect');
            return;
        }

        var attrRangeInfo = this.getAttrRangeInfo("infect", this.infect);
        if (attrRangeInfo) {
            var effect = attrRangeInfo.effect;
            for (var attr in effect) {
                if (this.hasOwnProperty(attr)) {
                    var value = effect[attr];
                    //感染属性影响中有公式
                    //对血的影响为公式
                    if (attr === 'hp') {
                        value *= memoryUtil.decode(this.infect) / 100;
                        value = Math.ceil(value);
                        this.deathCausedInfect = true;
                    }
                    if (attr === 'infect' || attr === 'spirit') {
                        //非服药状态才能影响这两个属性
                        if (!this.isInCure()) {
                            this.changeAttr(attr, value);
                        }
                    } else {
                        this.changeAttr(attr, value);
                    }
                }
            }
        }

        if (memoryUtil.decode(this.hp) === 0) {
            this.log.addMsg(1108);
        } else {
            this.deathCausedInfect = false;
        }
    },

    updateVigour: function () {
        if (this.buffManager.isBuffEffect(BuffItemEffectType.ITEM_1107032)) {
            cc.d('ITEM_1107032 updateVigour ');
            return;
        }

        var attrRangeInfo = this.getAttrRangeInfo("vigour", this.vigour);
        if (attrRangeInfo) {
            var effect = attrRangeInfo.effect;
            for (var attr in effect) {
                if (this.hasOwnProperty(attr)) {
                    this.changeAttr(attr, effect[attr]);
                }
            }
        }

    },

    updateInjure: function () {

        var attrRangeInfo = this.getAttrRangeInfo("injury", this.injury);
        if (attrRangeInfo) {
            var effect = attrRangeInfo.effect;
            for (var attr in effect) {
                if (this.hasOwnProperty(attr)) {
                    if (attr === 'infect' || attr === 'spirit') {
                        //非服药状态才能影响这两个属性
                        if (!this.isInBind()) {
                            this.changeAttr(attr, effect[attr]);
                        }
                    } else {
                        this.changeAttr(attr, effect[attr]);
                    }
                }
            }
        }

    },

    updateTemperature: function () {

        var c = this.config["temperature"];

        var temperature = this.initTemperature();

        if (player.roleType === RoleType.YAZI) {
            //电炉
            if (this.room.getBuild(18).isActive()) {
                temperature += c[4][0];
            }
        } else {
            //火炉
            if (this.room.getBuild(5).isActive()) {
                temperature += c[4][0];
            }
        }

        //天气
        temperature += this.weather.getValue("temperature");


        this.changeTemperature(temperature - memoryUtil.decode(this.temperature));
    },

    updateTemperatureEffect: function () {

        var attrRangeInfo = this.getAttrRangeInfo("temperature", this.temperature);
        if (attrRangeInfo) {
            var effect = attrRangeInfo.effect;
            for (var attr in effect) {
                if (this.hasOwnProperty(attr)) {
                    this.changeAttr(attr, effect[attr]);
                }
            }
        }

    },

    initTemperature: function () {
        var c = this.config["temperature"];
        //季节因素
        var configBySeason = c[cc.timer.getSeason()];
        var temperature = configBySeason[0];
        //日夜因素
        if (cc.timer.getStage() === "day") {
            temperature += configBySeason[1];
        } else {
            temperature += configBySeason[2];
        }
        return temperature;
    },

    cost: function (list) {
        var self = this;
        list.forEach(function (itemInfo) {
            self.storage.decreaseItem(itemInfo.itemId, itemInfo.num);
        });
    },

    getAttrRangeInfo: function (attr, value) {
        var res;
        var config = playerAttrEffect[attr];
        if (config) {
            value = memoryUtil.decode(value);
            for (var rangeId in config) {
                var range = new Range(config[rangeId].range);
                if (range.isInRange(value)) {
                    res = config[rangeId];
                    break;
                }
            }
        }
        return res;
    },

    getAttrStr: function (attr, value) {
        var value = value === undefined ? this[attr] : value;
        var attrRangeInfo = this.getAttrRangeInfo(attr, value);
        if (attrRangeInfo) {
            var res = stringUtil.getString(attr + "_name")[Number(attrRangeInfo.id) - 1];
            return res ? res : "";
        } else {
            return "";
        }
    },

    gainItems: function (items) {
        var self = this;
        items.forEach(function (item) {
            self.storage.increaseItem(item.itemId, item.num);
        });
    },

    gainItemsInBag: function (items) {
        var self = this;
        items.forEach(function (item) {
            self.bag.increaseItem(item.itemId, item.num);
        });
    },

    costItems: function (items) {
        var self = this;
        items.forEach(function (item) {
            self.storage.decreaseItem(item.itemId, item.num);
        });
    },

    validateItems: function (items) {
        var self = this;
        var res = true;
        items.forEach(function (item) {
            item.haveNum = self.storage.getNumByItemId(item.itemId);
            if (!self.storage.validateItem(item.itemId, item.num)) {
                res = false;
            }
        });
        return res;
    },

    costItemsInBag: function (items) {
        var self = this;
        items.forEach(function (item) {
            self.bag.decreaseItem(item.itemId, item.num);
        });
    },

    validateItemsInBag: function (items) {
        var self = this;
        var res = true;
        items.forEach(function (item) {
            item.haveNum = self.bag.getNumByItemId(item.itemId);
            if (!self.bag.validateItem(item.itemId, item.num)) {
                res = false;
            }
        });
        return res;
    },

    useItem: function (storage, itemId) {
        cc.e("useItem " + itemId);
        if (storage.validateItem(itemId, 1)) {
            var item = storage.getItem(itemId);
            var itemName = stringUtil.getString(itemId).title;
            if (item.isType(ItemType.TOOL, ItemType.FOOD)) {
                if (!uiUtil.checkStarve())
                    return {result: false};
                storage.decreaseItem(itemId, 1);
                this.log.addMsg(1093, itemName, storage.getNumByItemId(itemId));
                this.itemEffect(item, item.getFoodEffect());
                return {result: true};
            } else if (item.isType(ItemType.TOOL, ItemType.MEDICINE)) {
                if (itemId == 1104011) {
                    storage.decreaseItem(itemId, 1);
                    this.log.addMsg(1094, itemName, storage.getNumByItemId(itemId));
                    this.itemEffect(item, item.getMedicineEffect());
                    this.bindUp();
                } else {
                    storage.decreaseItem(itemId, 1);
                    this.log.addMsg(1095, itemName, storage.getNumByItemId(itemId));
                    if (itemId == 1104032) {
                        var res = this.item1104032Effect(item, item.getMedicineEffect());
                        if (res) {
                            this.cure();
                        }
                    } else {
                        this.itemEffect(item, item.getMedicineEffect());
                        this.cure();
                    }
                }
                return {result: true};
            } else if (item.isType(ItemType.TOOL, ItemType.BUFF)) {
                storage.decreaseItem(itemId, 1);
                this.log.addMsg(1095, itemName, storage.getNumByItemId(itemId));
                this.buffManager.applyBuff(itemId);
                return {result: true};
            } else {
                return {result: false, type: 2, msg: "this type can't use"};
            }
        } else {
            return {result: false, type: 1, msg: "not enough"};
        }
    },
    //自制青霉素的使用,如果扣血成功,则不发生治疗效果
    item1104032Effect: function (item, obj) {
        var hpChance = obj.hp_chance;
        var rand = Math.random();
        cc.log(" hpChance=" + hpChance + " rand=" + rand)
        if (rand <= hpChance) {
            cc.log("1104032 worked");
            this.changeHp(obj.hp);
            return false;
        } else {
            var newObj = {};
            for (var key in obj) {
                if (key.indexOf("hp") == -1) {
                    newObj[key] = obj[key];
                }
            }
            this.itemEffect(item, newObj);
            return true;
        }
    },
    applyEffect: function (obj) {
        var badEffect = [];
        for (var key in obj) {
            if (this.hasOwnProperty(key)) {
                var chance = obj[key + "_chance"];
                var rand = Math.random();
                cc.log(key + " chance=" + chance + " rand=" + rand)
                if (rand <= chance) {
                    cc.log("worked");
                    var funName = cc.formatStr("change%s%s", key.substr(0, 1).toUpperCase(), key.substr(1));
                    cc.log(funName);
                    var changeValue = obj[key];
                    this[funName](changeValue);
                    if (!this.isAttrChangeGood(key, changeValue)) {
                        badEffect.push({
                            attrName: key,
                            changeValue: changeValue
                        });
                    }
                }
            }
        }
        return badEffect;
    },

    itemEffect: function (item, obj) {
        var badEffect = this.applyEffect(obj);

        if (badEffect.length > 0) {
            var str = "";
            badEffect.forEach(function (obj) {
                str += stringUtil.getString(obj.attrName) + ":" + obj.changeValue + " ";
            });
            this.log.addMsg(1107, stringUtil.getString(item.id).title, str);
        }
    },

    _getAttackInNightStrength: function () {
        var timeObj = cc.timer.formatTime();
        var strength = 0;
        for (var i = 0; i < MoonlightingConfig.strength.length; i++) {
            var strengthObj = MoonlightingConfig.strength[i];
            if (timeObj.d >= strengthObj.day[0] && timeObj.d <= (strengthObj.day[1] ? strengthObj.day[1] : Number.MAX_VALUE)) {
                strength = utils.getRandomInt(strengthObj.strength[0], strengthObj.strength[1]);
                break;
            }
        }
        return strength;
    },
    _getHomeDef: function () {
        //家的防御 = 栅栏等级*n + 狗(活跃+10)
        var homeDef = 0;
        var level = this.room.getBuildLevel(11);
        if (level >= 0) {
            homeDef += (level + 1) * 10;
        }
        if (this.dog.isActive()) {
            homeDef += 10;
        }
        return homeDef;
    },
    _getLuoHomeDef: function () {
        var homeDef = 0;
        if (this.dog.isActive()) {
            homeDef += 10;
        }
        return homeDef;
    },
    _getYaziHomeDef: function () {
        return this._getLuoHomeDef();
    },
    _getAttackResult: function (attackStrength, def, causeStorage) {
        var res = {};
        cc.d("monster strength=" + attackStrength + " def=" + def);
        if (attackStrength > def) {
            var produceValue = attackStrength / 5 - 1 + 3;
            cc.i("moonlighting defeat value=" + produceValue);
            var tmpStorage = new Storage();
            var tmpBlackList = blackList.storageLost.concat();
            while (produceValue > 0 && !causeStorage.isEmpty()) {

                var ids = Object.keys(causeStorage.map);
                var haveIds = Object.keys(tmpStorage.map);

                haveIds.forEach(function (id) {
                    var num = tmpStorage.getNumByItemId(id);
                    if (num >= 5 && tmpBlackList.indexOf(Number(id)) === -1) {
                        tmpBlackList.push(Number(id));
                    }
                });

                ids = ids.filter(function (id) {
                    return tmpBlackList.indexOf(Number(id)) === -1
                });

                if (haveIds.length >= 6) {
                    ids = ids.filter(function (id) {
                        return haveIds.indexOf(Number(id)) !== -1
                    });
                }

                if (ids.length > 0) {
                    var itemId = ids[utils.getRandomInt(0, ids.length - 1)];
                    if (causeStorage.validateItem(itemId, 1)) {
                        causeStorage.decreaseItem(itemId, 1);
                        tmpStorage.increaseItem(itemId, 1);
                        var value = itemConfig[itemId].value;
                        produceValue -= value;
                    }
                } else {
                    break;
                }
            }
            res.win = false;
            res.items = [];
            tmpStorage.forEach(function (item, num) {
                res.items.push({itemId: item.id, num: num});
            });
        } else {
            res.win = true;
        }
        return res;
    },
    underAttackInNight: function () {
        var homeRes = {};
        var rand = Math.random();
        if (cc.timer.formatTime().d < 2) {
            rand = 1;
        } else {
            rand = Math.random();
        }
        cc.i("moonlighting..." + rand);
        if (rand <= MoonlightingConfig.probability) {

            player.log.addMsg(1099);

            var electricFenceBuild = this.room.getBuild(19);

            //雷区抵御僵尸夜袭
            if (this.isBombActive) {

                this.isBombActive = false;
                homeRes.happened = true;
                homeRes.defend = true;

            } else if (electricFenceBuild && electricFenceBuild.isActive()) {  //电网抵御僵尸
                homeRes.happened = true;
                homeRes.defend = true;
            } else {
                var attackStrength = this._getAttackInNightStrength();
                var homeDef;
                if (role.getChoosenRoleType() === RoleType.LUO) {
                    homeDef = this._getLuoHomeDef();
                } else if (role.getChoosenRoleType() === RoleType.YAZI) {
                    homeDef = this._getYaziHomeDef();
                } else {
                    homeDef = this._getHomeDef();
                }
                homeRes = this._getAttackResult(attackStrength, homeDef, this.storage);
                homeRes.happened = true;

                for (var siteId in this.map.siteMap) {
                    var site = this.map.siteMap[siteId];
                    if (!site.closed && !site.storage.isEmpty()) {
                        this._getAttackResult(attackStrength, site.config.def, site.storage);
                        site.isUnderAttacked = true;
                    }
                }
            }


        } else {
            homeRes.happened = false;
        }

        Record.saveAll();

        cc.timer.pause();
        new DayLayer(homeRes).show();
    },

    randomAttack: function (cb) {
        var stage = cc.timer.getStage();
        var config = RandomBattleConfig[stage];
        var rand = Math.random();
        cc.d(rand);
        if (rand <= config.probability) {

            player.log.addMsg(1113);

            var diff = utils.getRandomInt(config.difficulty[0], config.difficulty[1]);
            var list = utils.getMonsterListByDifficulty(diff)
            cc.e("action")
            uiUtil.showRandomBattleDialog({
                difficulty: diff,
                list: list
            }, cb);
            return true;
        }
        return false;
    },
    start: function () {
        cc.i("player start...");
        var self = this;
        cc.timer.addTimerCallbackDayAndNight(null, function (flag) {
            if (flag === 'day') {
                self.npcManager.visitPlayer();
                self.npcManager.updateTradingItem();
                self.log.addMsg(1122);
                self.weather.checkWeather();
                Medal.checkDay(1);
            } else {
                self.log.addMsg(1121);
            }
        });
        cc.timer.addTimerCallbackDayByDay(this, function () {
            self.underAttackInNight();
            self.room.getBuild(9).sleeped = false;
            cc.timer.checkSeason();

            DataLog.genDayLog();

            adHelper.activeAd();
        });
        cc.timer.addTimerCallbackHourByHour(this, function () {
            self.updateByTime();
            self.updateTemperature();
            self.updateTemperatureEffect();
            self.updateStarve();
            self.updateInjure();
            self.updateInfect();
            self.updateVigour();

            var workSite = self.map.getSite(WORK_SITE);
            if (workSite) {
                workSite.checkActive();
            }

            var now = cc.timer.now();
            if (self.bindTime) {
                if (now - self.bindTime >= 24 * 60 * 60) {
                    self.binded = false;
                    cc.i("binded false");
                }
            }
            if (self.cureTime) {
                if (now - self.cureTime >= 24 * 60 * 60) {
                    self.cured = false;
                    cc.i("cured false");
                }
            }
        });
        cc.timer.addTimerCallbackByMinute(this.buffManager);
        //this.map.unlockNpc(1);
    },
    //背包+仓库的物品数量
    getItemNumInPlayer: function (itemId) {
        var num = 0;
        num += this.bag.getNumByItemId(itemId);
        num += this.storage.getNumByItemId(itemId);
        return num;
    },
    die: function () {
        this.buffManager.abortBuff();

        game.stop();

        this.map.resetPos();
        this.map.deleteUnusableSite();

        Navigation.gotoDeathNode();

        if (player.isAtSite) {
            DataLog.genSiteLog(player.nowSiteId, 2);
        }

        DataLog.genDeathLog();
    },
    //重生
    relive: function () {
        this.changeSpirit(memoryUtil.decode(this.spiritMax) - memoryUtil.decode(this.spirit));
        this.changeStarve(memoryUtil.decode(this.starveMax) - memoryUtil.decode(this.starve));
        this.changeVigour(memoryUtil.decode(this.vigourMax) - memoryUtil.decode(this.vigour));
        this.changeInjury(0 - memoryUtil.decode(this.injury));
        this.changeInfect(0 - memoryUtil.decode(this.infect));
        this.changeAttr("hp", memoryUtil.decode(this.hpMax));
        this.isInSleep = false;
        this.cured = false;
        this.binded = false;
        //所有建筑需要复原
        this.room.forEach(function (build) {
            build.resetActiveBtnIndex();
        });
        Record.saveAll();
    },

    isLowVigour: function () {
        if (this.buffManager.isBuffEffect(BuffItemEffectType.ITEM_1107032)) {
            return false;
        } else {
            var attrRangeInfo = this.getAttrRangeInfo("vigour", this.vigour);
            if (attrRangeInfo) {
                return attrRangeInfo.id === 1;
            } else {
                return false;
            }
        }
    },
    vigourEffect: function () {
        return this.isLowVigour() ? 2 : 1;
    },

    setSetting: function (key, value) {
        this.setting[key] = value;
        Record.saveAll();
    },
    getSetting: function (key, defaultValue) {
        if (this.setting.hasOwnProperty(key)) {
            return this.setting[key];
        } else {
            return defaultValue;
        }
    },
    getStep: function () {
        return this.getSetting("step", 0);
    },
    step: function () {
        var step = this.getStep();
        step++;
        this.setSetting("step", step);
    }
});

var Dog = cc.Class.extend({
    ctor: function () {
        //饥饿
        this.starve = 0;
        this.starveMax = 100;
    },

    changeAttr: function (key, value) {
        this[key] += value;
        this[key] = cc.clampf(this[key], 0, this[key + "Max"]);
        cc.i("dog changeAttr " + key + " value:" + value + " after:" + this[key]);
    },

    changeStarve: function (value) {
        this.changeAttr("starve", value);
    },
    canFeed: function () {
        return this.starve < this.starveMax;
    },
    feed: function () {
        this.changeStarve(this.starveMax - this.starve);
    },
    isActive: function () {
        return this.starve > 0;
    },
    save: function () {
        var opt = {
            starve: this.starve
        };
        return opt;
    },

    restore: function (opt) {
        if (opt) {
            this.starve = opt.starve;
        }
    }
});

